;************************************************************************************************************;
;                  . PIC16F84 4 mHz MT-10T7  .. 2010                               ;
;************************************************************************************************************;
;                                                                                              ;
;============================================================================================================;
;                                                                                       ;
;------------------------------------------------------------------------------------------------------------;
                    LIST           p=16F84a               ;                      ;
                    __CONFIG       03FF1H                 ;                           ;
;------------------------------------------------------------------------------------------------------------;
;                                                                  ;
;------------------------------------------------------------------------------------------------------------;
Indf                equ            00h                    ;                         ;
TMR0                equ            01h                    ;                                    ;
OptionR             equ            01h                    ; Option ( 1)                           ;
PCL                 equ            02h                    ;                      ;
Status              equ            03h                    ; Status                                    ;
FSR                 equ            04h                    ;                   ;
PortA               equ            05h                    ; Port A                                    ;
TrisA               equ            05h                    ;     ( 1)       ;
PortB               equ            06h                    ; Pjrt B                                    ;
TrisB               equ            06h                    ;     ( 1)       ;
IntCon              equ            0Bh                    ;                     ;
;------------------------------------------------------------------------------------------------------------;
;                                                                        ;
;------------------------------------------------------------------------------------------------------------;
SCH1                equ            0Ch                    ;                              ;
TEMPw               equ            0Dh                    ;                            ;
TEMPstatus          equ            0Eh                    ;                                ;
INTAIM              equ            0Fh                    ;                                 ;
ZM1                 equ            10h                    ; 1                     ;
ZM2                 equ            11h                    ; 2                     ;
ZM3                 equ            12h                    ; 3                     ;
ZM4                 equ            13h                    ; 4                     ;
ZM5                 equ            14h                    ; 5                     ;
ZM6                 equ            15h                    ; 6                     ;
ZM7                 equ            16h                    ; 7                     ;
ZM8                 equ            17h                    ; 8                     ;
ZM9                 equ            18h                    ; 9                     ;
ZM10                equ            19h                    ; 10                    ;
FLAG                equ            1Ah                    ;                                     ;
MEM                 equ            1Bh                    ;                               ;
TIME1s              equ            1Ch                    ;   1                          ;
TIME1m              equ            1Dh                    ;   1                           ;
TIME1c              equ            1Eh                    ;   1                           ;
TIME2s              equ            1Fh                    ;   2                          ;
TIME2m              equ            20h                    ;   2                           ;
TIME2c              equ            21h                    ;   2                           ;
TIME3s              equ            22h                    ;   3                          ;
TIME3m              equ            23h                    ;   3                           ;
TIME3c              equ            24h                    ;   3                           ;
TIME4s              equ            25h                    ;   4                          ;
TIME4m              equ            26h                    ;   4                           ;
TIME4c              equ            27h                    ;   4                           ;
TIMEs               equ            28h                    ;                      ;
TIMEm               equ            29h                    ;                       ;
TIMEc               equ            2Ah                    ;                       ;
SCHBP               equ            2Bh                    ;   2-10                     ;
ZMTH                equ            2Ch                    ;                 ;
ZMTL                equ            2Dh                    ;                ;
TIMEt               equ            2Eh                    ;                            ;
FSTOP               equ            2Fh                    ;                             ;
ZFLAG               equ            30h                    ;             ;
TECNT               equ            31h                    ;              ;
SNKK                equ            32h                    ;                       ;
KEYplusT            equ            33h                    ;    "+ "        ;
KEYplusVrema        equ            34h                    ;    "+ "         ;
KEYstasto           equ            35h                    ;   -     ;
BIP                 equ            36h                    ;                       ;
BIP2                equ            37h                    ;                ;
;------------------------------------------------------------------------------------------------------------;
;                                                                ;
;------------------------------------------------------------------------------------------------------------;
W                   equ            0                      ;                     ;
F                   equ            1                      ;                  ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                     ;
;------------------------------------------------------------------------------------------------------------;
DO                  equ            0                      ;                    ;
C                   equ            0                      ; -                               ;
DO1                 equ            1                      ;                   ;
T0IF                equ            2                      ;               ;
Z                   equ            2                      ;                             ;
FSIG                equ            2                      ;      ;
A0                  equ            4                      ;  \                           ;
T1                  equ            4                      ;                          ;
BITZ                equ            4                      ;                                  ;
WR1                 equ            5                      ;                             ;
TOIE                equ            5                      ;     TMR0    ;
RP0                 equ            5                      ;                                    ;
T2                  equ            5                      ;                          ;
T3                  equ            6                      ;                         ;
GIE                 equ            7                      ;                ;
BtZ                 equ            7                      ;                            ;
T4                  equ            7                      ;                       ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                       ;
;------------------------------------------------------------------------------------------------------------;
                    org            0                      ;                         ;
                    goto           START                  ;  START                              ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                       ;
;------------------------------------------------------------------------------------------------------------;
                    org            4                      ;                                ;
                    goto           INTERR                 ;                             ;
;************************************************************************************************************;
;                                                                                       ;
;============================================================================================================;
;                                                                     ;
;------------------------------------------------------------------------------------------------------------;
TablSymv            addwf          PCL,F                  ;                          ;
                    retlw          b'01110111'            ; 0 (0x00)                               ;
                    retlw          b'01100000'            ; 1 (0x01)                               ;
                    retlw          b'01001111'            ; 2 (0x02)                               ;
                    retlw          b'01101011'            ; 3 (0x03)                               ;
                    retlw          b'01111000'            ; 4 (0x04)                               ;
                    retlw          b'00111011'            ; 5 (0x05)                               ;
                    retlw          b'00111111'            ; 6 (0x06)                               ;
                    retlw          b'01100001'            ; 7 (0x07)                               ;
                    retlw          b'01111111'            ; 8 (0x08)                               ;
                    retlw          b'01111011'            ; 9 (0x09)                               ;
                    retlw          b'00011110'            ; t (0x0A)                               ;
                    retlw          b'00101100'            ; n (0x0B)                               ;
                    retlw          b'00001010'            ; = (0x0C)                               ;
                    retlw          b'00001000'            ; - (0x0D)                               ;
                    retlw          b'00000000'            ;  (0x0E)                          ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                      ;
;------------------------------------------------------------------------------------------------------------;
TABLadr             addwf          PCL,F                  ;                          ;
                    nop                                   ;   0                         ;
                    retlw          0x1C                   ;                               ;
                    retlw          0x1F                   ;                               ;
                    retlw          0x22                   ;                              ;
                    retlw          0x25                   ;                            ;
;------------------------------------------------------------------------------------------------------------;
;                                                                          ;
;------------------------------------------------------------------------------------------------------------;
KNOBKIt             decfsz         KEYplusVrema,F         ;                  ;
                    return                                ; ,                               ;
                    movf           TECNT,W                ;         ;
                    addwf          PCL,F                  ;                          ;
                    nop                                   ;                ;
                    goto           OBRT1                  ;                          ;
                    goto           OBRT2                  ;                          ;
                    goto           OBRT3                  ;                          ;
                    goto           OBRT4                  ;                       ;
OBRT1               btfsc          FLAG,T1                ;            ;
                    return                                ; ,                                ;
                    bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,1                ;  ,                        ;
                    goto           KEYMINUTE1             ;                         ;
                    call           BIPER                  ;                                 ;
                    incf           TIME1c,F               ;                              ;
                    movf           TIME1c,W               ;                                        ;
                    sublw          .24                    ;                  ;
                    btfss          Status,Z               ;      24                     ;
                    goto           KEYMINUTE1             ; ,         ;
                    clrf           TIME1c                 ;---------------------------------------------     ;
KEYMINUTE1          bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,2                ;  ,                          ;
                    goto           KEYSECUNDE1            ;                        ;
                    call           BIPER                  ;                                 ;
                    incf           TIME1m,F               ;  ,                 ;
                    movf           TIME1m,W               ;                                        ;
                    sublw          .60                    ;                   ;
                    btfss          Status,Z               ;   60                                    ;
                    goto           KEYSECUNDE1            ;  ,        ;
                    clrf           TIME1m                 ;  ,                    ;
KEYSECUNDE1         bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,3                ;  ,                              ;
                    return                                ;                              ;
                    call           BIPER                  ;                                 ;
                    incf           TIME1s,F               ;                           ;
                    movf           TIME1s,W               ;        ;
                    sublw          .60                    ;   60                                    ;
                    btfss          Status,Z               ;---------------------------------------------     ;
                    return                                ;  ,              ;
                    clrf           TIME1s                 ;  ,                           ;
                    return                                ;                                          ;
OBRT2               btfsc          FLAG,T2                ;            ;
                    return                                ; ,                                ;
                    bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,1                ;  ,                        ;
                    goto           KEYMINUTE2             ;                         ;
                    call           BIPER                  ;                                 ;
                    incf           TIME2c,F               ;                              ;
                    movf           TIME2c,W               ;                                        ;
                    sublw          .24                    ;                  ;
                    btfss          Status,Z               ;      24                     ;
                    goto           KEYMINUTE2             ; ,         ;
                    clrf           TIME2c                 ;---------------------------------------------     ;
KEYMINUTE2          bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,2                ;  ,                          ;
                    goto           KEYSECUNDE2            ;                        ;
                    call           BIPER                  ;                                 ;
                    incf           TIME2m,F               ;  ,                 ;
                    movf           TIME2m,W               ;                                        ;
                    sublw          .60                    ;                   ;
                    btfss          Status,Z               ;   60                                    ;
                    goto           KEYSECUNDE2            ;  ,        ;
                    clrf           TIME2m                 ;  ,                    ;
KEYSECUNDE2         bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,3                ;  ,                              ;
                    return                                ;                              ;
                    call           BIPER                  ;                                 ;
                    incf           TIME2s,F               ;                           ;
                    movf           TIME2s,W               ;        ;
                    sublw          .60                    ;   60                                    ;
                    btfss          Status,Z               ;---------------------------------------------     ;
                    return                                ;  ,              ;
                    clrf           TIME2s                 ;  ,                           ;
                    return                                ;                                          ;
OBRT3               btfsc          FLAG,T3                ;            ;
                    return                                ; ,                                ;
                    bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,1                ;  ,                        ;
                    goto           KEYMINUTE3             ;                         ;
                    call           BIPER                  ;                                 ;
                    incf           TIME3c,F               ;                              ;
                    movf           TIME3c,W               ;                                        ;
                    sublw          .24                    ;                  ;
                    btfss          Status,Z               ;      24                     ;
                    goto           KEYMINUTE3             ; ,         ;
                    clrf           TIME3c                 ;---------------------------------------------     ;
KEYMINUTE3          bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,2                ;  ,                          ;
                    goto           KEYSECUNDE3            ;                        ;
                    call           BIPER                  ;                                 ;
                    incf           TIME3m,F               ;  ,                 ;
                    movf           TIME3m,W               ;                                        ;
                    sublw          .60                    ;                   ;
                    btfss          Status,Z               ;   60                                    ;
                    goto           KEYSECUNDE3            ;  ,        ;
                    clrf           TIME3m                 ;  ,                    ;
KEYSECUNDE3         bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,3                ;  ,                              ;
                    return                                ;                              ;
                    call           BIPER                  ;                                 ;
                    incf           TIME3s,F               ;                           ;
                    movf           TIME3s,W               ;        ;
                    sublw          .60                    ;   60                                    ;
                    btfss          Status,Z               ;---------------------------------------------     ;
                    return                                ;  ,              ;
                    clrf           TIME3s                 ;  ,                           ;
                    return                                ;                                          ;
OBRT4               btfsc          FLAG,T4                ;            ;
                    return                                ; ,                                ;
                    bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,1                ;  ,                        ;
                    goto           KEYMINUTE4             ;                         ;
                    call           BIPER                  ;                                 ;
                    incf           TIME4c,F               ;                              ;
                    movf           TIME4c,W               ;                                        ;
                    sublw          .24                    ;                  ;
                    btfss          Status,Z               ;      24                     ;
                    goto           KEYMINUTE4             ; ,         ;
                    clrf           TIME4c                 ;---------------------------------------------     ;
KEYMINUTE4          bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,2                ;  ,                          ;
                    goto           KEYSECUNDE4            ;                        ;
                    call           BIPER                  ;                                 ;
                    incf           TIME4m,F               ;  ,                 ;
                    movf           TIME4m,W               ;                                        ;
                    sublw          .60                    ;                   ;
                    btfss          Status,Z               ;   60                                    ;
                    goto           KEYSECUNDE4            ;  ,        ;
                    clrf           TIME4m                 ;  ,                    ;
KEYSECUNDE4         bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,3                ;  ,                              ;
                    return                                ;                              ;
                    call           BIPER                  ;                                 ;
                    incf           TIME4s,F               ;                           ;
                    movf           TIME4s,W               ;        ;
                    sublw          .60                    ;   60                                    ;
                    btfss          Status,Z               ;---------------------------------------------     ;
                    return                                ;  ,              ;
                    clrf           TIME4s                 ;  ,                           ;
                    return                                ;                                          ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                   ;
;------------------------------------------------------------------------------------------------------------;
PERECOD             movlw          0x10                   ;            ;
                    movwf          FSR                    ;                             ;
                    movlw          .10                    ;                      ;
                    movwf          SCH1                   ;                                          ;
PER                 movf           Indf,W                 ;                   ;
                    call           TablSymv               ;                            ;
                    movwf          Indf                   ;        ;
                    incf           FSR,F                  ;               ;
                    decfsz         SCH1,F                 ;                          ;
                    goto           PER                    ;    ,       ;
                    return                                ;  ,                  ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                 ;
;------------------------------------------------------------------------------------------------------------;
CLERREG             movlw          .10                    ;               ;
                    movwf          SCH1                   ;                                          ;
                    movlw          0x10                   ;          ;
                    movwf          FSR                    ;                             ;
CLR                 clrf           Indf                   ;                             ;
                    incf           FSR,F                  ;                                  ;
                    decfsz         SCH1,F                 ;                ;
                    goto           CLR                    ;                                 ;
                    return                                ;  ,                 ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                            ;
;------------------------------------------------------------------------------------------------------------;
ZAGRUZKA            call           PERECOD                ;                   ;
                    bsf            ZM6,BtZ                ;                              ;
                    bsf            ZM8,BtZ                ;------------------------------------------        ;
                    movlw          .10                    ;           ;
                    movwf          SCH1                   ;                                          ;
                    movlw          0x10                   ;         ;
                    movwf          FSR                    ;                             ;
                    clrf           PortB                  ;                     ;
                    bcf            PortB,A0               ;                     ;
                    bsf            PortB,WR1              ;                                    ;
                    bcf            PortB,WR1              ;-----------------------------------------         ;
                    bsf            PortB,A0               ;                   ;
ZAGR                movf           Indf,W                 ;                 ;
                    andlw          b'00001111'            ;                             ;
                    movwf          MEM                    ;               ;
                    bsf            MEM,A0                 ;                            ;
                    movf           MEM,W                  ;                           ;
                    movwf          PortB                  ;                                  ;
                    bsf            PortB,WR1              ;                                    ;
                    bcf            PortB,WR1              ;-----------------------------------------         ;
                    swapf          Indf,W                 ;            ;
                    andlw          b'00001111'            ;                             ;
                    movwf          MEM                    ;                 ;
                    bsf            MEM,A0                 ;                                 ;
                    movf           MEM,W                  ;                               ;
                    movwf          PortB                  ;                         ;
                    bsf            PortB,WR1              ;                                    ;
                    bcf            PortB,WR1              ;-----------------------------------------         ;
                    incf           FSR,F                  ;               ;
                    decfsz         SCH1,F                 ;        ;
                    goto           ZAGR                   ;                                 ;
                    call           CLERREG                ;  ,     ;
                    return                                ;                                   ;
;------------------------------------------------------------------------------------------------------------;
;                                                                      ;
;------------------------------------------------------------------------------------------------------------;
PER2_10             bcf            Status,C               ;  -                    ;
                    movlw          .8                     ;                             ;
                    movwf          SCHBP                  ;                                          ;
                    clrf           ZMTL                   ;                          ;
                    clrf           ZMTH                   ;------------------------------------------        ;
Loop                rlf            TIMEt,F                ;                                  ;
                    rlf            ZMTL,F                 ;------------------------------------------        ;
                    rlf            ZMTH,F                 ;------------------------------------------        ;
                    decfsz         SCHBP,F                ;    1                   ;
                    goto           adjDEC                 ;   ,                ;
                    swapf          ZMTL,W                 ;             ;
                    andlw          0x0F                   ;                        ;
                    movwf          ZMTH                   ;                             ;
                    movfw          ZMTL                   ;                ;
                    andlw          0x0F                   ;                                    ;
                    movwf          ZMTL                   ;                                        ;
                    return                                ;                               ;
adjDEC              movlw          0x2D                   ;                       ;
                    movwf          FSR                    ; FSR                                             ;
                    call           adjBCD                 ;                          ;                              
                    movlw          0x2C                   ;                        ;
                    movwf          FSR                    ; FSR                                             ;
                    call           adjBCD                 ;                          ;
                    goto           Loop                   ;                                   ;
adjBCD              movlw          0x03                   ;  003            ;  
                    addwf          Indf,W                 ;------------------------------------------        ;
                    movwf          MEM                    ;               ;
                    btfsc          MEM,3                  ;                    ;
                    movwf          Indf                   ;   0          ;
                    movlw          0x30                   ;  0     030                ;
                    addwf          Indf,W                 ;------------------------------------------        ;
                    movwf          MEM                    ;                     ;
                    btfsc          MEM,7                  ;                   ;
                    movwf          Indf                   ;   0          ;
                    retlw          0x00                   ;  0     0  ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                           ;
;------------------------------------------------------------------------------------------------------------;
ZUM                 bcf            FLAG,FSIG              ;             ;
                    btfsc          FSTOP,T1               ;      1           ;
                    goto           SIGN                   ;                        ;
                    btfsc          FSTOP,T2               ; ,                  ;
                    goto           SIGN                   ;  ,             ;
                    btfsc          FSTOP,T3               ; ,                     ;
                    goto           SIGN                   ;  ,                   ;
                    btfsc          FSTOP,T4               ; ,               ;
                    goto           SIGN                   ;  ,                   ;
                    bcf            PortA,BITZ             ;        ;
                    return                                ;  ,               ;
SIGN                bsf            FLAG,FSIG              ;             ;
                    btfsc          ZFLAG,0                ;                            ;
                    bsf            PortA,BITZ             ;  1,      1                 ;
                    btfss          ZFLAG,0                ;   0,     0                 ;
                    bcf            PortA,BITZ             ;-------------------------------------------       ;
                    return                                ;                                          ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                           ;
;------------------------------------------------------------------------------------------------------------;
TIMEtemp            btfsc          FLAG,FSIG              ;             ;
                    goto           ISKAT                  ;                               ;
                    decfsz         KEYplusT,F             ;       ;
                    goto           PERADR                 ;   ,     ;
                    bsf            PortB,7                ;                                ;
                    bcf            PortB,6                ;                 ;
                    btfsc          PortA,0                ;  ,          ;
                    goto           PERADR                 ;-------------------------------------------       ;
                    call           BIPER                  ;                                 ;
                    bsf            PortB,6                ;  ,                   ;
                    incf           TECNT,F                ;    1                   ;
                    movf           TECNT,W                ;     5                        ;
                    sublw          0x05                   ;-------------------------------------------       ;
                    btfsc          Status,Z               ;-------------------------------------------       ;
                    goto           TimST1                 ; ,   01             ;
                    goto           PERADR                 ; ,             ;
ISKAT               btfsc          FSTOP,T1               ;      1           ;
                    goto           TimST1                 ;                        ;
                    btfsc          FSTOP,T2               ; ,                  ;
                    goto           TimST2                 ;  ,             ;
                    btfsc          FSTOP,T3               ; ,                     ;
                    goto           TimST3                 ;  ,                   ;
                    btfsc          FSTOP,T4               ; ,               ;
                    goto           TimST4                 ;  ,                   ;
TimST1              movlw          0x01                   ;   1                        ;
                    movwf          TECNT                  ;                           ;
                    goto           PERADR                 ;               ;
TimST2              movlw          0x02                   ;   1                        ;
                    movwf          TECNT                  ;                           ;
                    goto           PERADR                 ;               ;
TimST3              movlw          0x03                   ;   1                        ;
                    movwf          TECNT                  ;                           ;
                    goto           PERADR                 ;               ;
TimST4              movlw          0x04                   ;   1                        ;
                    movwf          TECNT                  ;                           ;
PERADR              movf           TECNT,W                ;               ;
                    call           TABLadr                ;                                         ;
                    movwf          FSR                    ;    FSR               ;
                    movf           Indf,W                 ;          ;
                    movwf          TIMEs                  ;                                     ;
                    incf           FSR,F                  ;                                 ;
                    movf           Indf,W                 ;              ;
                    movwf          TIMEm                  ;                                     ;
                    incf           FSR,F                  ;                           ;
                    movf           Indf,W                 ;                              ;
                    movwf          TIMEc                  ;                                       ;
                    return                                ;                                          ;
;------------------------------------------------------------------------------------------------------------;
;                                         \                                  ;
;------------------------------------------------------------------------------------------------------------;
KNOBKIss            decfsz         KEYstasto,F            ;               ;
                    return                                ; ,                             ;
                    bcf            PortB,7                ;                                ;
                    bsf            PortB,6                ;                 ;
                    btfsc          PortA,0                ;  ,         ;
                    goto           KEYSS2                 ;-------------------------------------------       ;
                    call           BIPER                  ;                                 ;
                    btfss          FLAG,T1                ;                          ;
                    goto           STOPT1                 ;                                   ;
                    bcf            FLAG,T1                ;                                  ; 
                    goto           KEYSS2                 ;                       ;
STOPT1              btfsc          FSTOP,T1               ;  ,         ;
                    goto           ZBROS1                 ; ,    ;
                    bsf            FLAG,T1                ;  ,                     ;
                    goto           KEYSS2                 ;                       ;
ZBROS1              bcf            FSTOP,T1               ;                   ;
KEYSS2              bcf            PortB,7                ;                                ;
                    bsf            PortB,6                ;                 ;
                    btfsc          PortA,1                ;  ,         ;
                    goto           KEYSS3                 ;-------------------------------------------       ;
                    call           BIPER                  ;                                 ;
                    btfss          FLAG,T2                ;                          ;
                    goto           STOPT2                 ;                                   ;
                    bcf            FLAG,T2                ;                                  ;
                    goto           KEYSS3                 ;                       ;
STOPT2              btfsc          FSTOP,T2               ;  ,         ;
                    goto           ZBROS2                 ; ,    ;
                    bsf            FLAG,T2                ;  ,                     ;
                    goto           KEYSS3                 ;                       ;
ZBROS2              bcf            FSTOP,T2               ;                   ;
KEYSS3              bcf            PortB,7                ;                                ;
                    bsf            PortB,6                ;                 ;
                    btfsc          PortA,2                ;  ,         ;
                    goto           KEYSS4                 ;-------------------------------------------       ;
                    call           BIPER                  ;                                 ;
                    btfss          FLAG,T3                ;                          ;
                    goto           STOPT3                 ;                                   ;
                    bcf            FLAG,T3                ;                                  ; 
                    goto           KEYSS4                 ;                       ;
STOPT3              btfsc          FSTOP,T3               ;  ,         ;
                    goto           ZBROS3                 ; ,    ;
                    bsf            FLAG,T3                ;  ,                     ;
                    goto           KEYSS4                 ;                       ;
ZBROS3              bcf            FSTOP,T3               ;                   ;
KEYSS4              bcf            PortB,7                ;                                ;
                    bsf            PortB,6                ;                 ;
                    btfsc          PortA,3                ;  ,                       ;
                    return                                ;-------------------------------------------       ;
                    call           BIPER                  ;                                 ;
                    btfss          FLAG,T4                ;                          ;
                    goto           STOPT4                 ;                                   ;
                    bcf            FLAG,T4                ;                                  ; 
                    return                                ;                       ;
STOPT4              btfsc          FSTOP,T4               ;  ,         ;
                    goto           ZBROS4                 ; ,    ;
                    bsf            FLAG,T4                ;  ,                     ;
                    return                                ;                       ;
ZBROS4              bcf            FSTOP,T4               ;                   ;
                    return                                ;                                          ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                            ;
;------------------------------------------------------------------------------------------------------------;
BIPER               movlw          .20                    ;                     ;
                    movwf          BIP2                   ;                                    ;
B2                  movlw          0xFF                   ;                     ;
                    movwf          BIP                    ;                                ;
                    bsf            PortA,BITZ             ;                                     ;
B1                  decfsz         BIP,F                  ;                            ;
                    goto           B1                     ;   0,                               ;
                    decfsz         BIP2                   ;                              ;
                    goto           B2                     ;   0,              ;
                    bcf            PortA,BITZ             ;  ,                        ;
                    return                                ;                                          ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                    ;
;------------------------------------------------------------------------------------------------------------;
START               clrf           IntCon                 ;                              ;
                    bsf            Status,RP0             ;                                ;
                    movlw          b'11101111'            ;                  ;
                    movwf          TrisA                  ;------------------------------------------        ;
                    movlw          b'00000000'            ;------------------------------------------        ;
                    movwf          TrisB                  ;------------------------------------------        ;
                    movlw          b'10000111'            ;              ;
                    movwf          OptionR                ;    256   TRM0         ;
                    bcf            Status,RP0             ;                               ;
                    movlw          b'00001111'            ;                            ;
                    movwf          PortA                  ;------------------------------------------        ;
                    clrf           PortB                  ;                                      ;
                    bcf            PortB,WR1              ;                                   ;
                    bsf            PortB,A0               ;                               ;
                    clrf           INTAIM                 ;                         ;
                    clrf           FLAG                   ;                                   ;
                    clrf           FSTOP                  ;                           ;
                    clrf           ZFLAG                  ;                   ;
                    movlw          0x01                   ;                     ;
                    movwf          TECNT                  ;------------------------------------------        ;
                    clrf           KEYplusT               ;    +             ;
                    clrf           KEYplusVrema           ;          ;
                    clrf           KEYstasto              ;    \    ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                ;
;------------------------------------------------------------------------------------------------------------;
                    movlw          0x0F                   ;                       ;
                    movwf          PortB                  ;-----------------------------------------         ;
                    bcf            PortB,A0               ;                         ;
                    bsf            PortB,WR1              ;                                        ;
                    bcf            PortB,WR1              ;-----------------------------------------         ;
                    clrf           PortB                  ;                       ;
                    bsf            PortB,A0               ;                         ;
                    bsf            PortB,WR1              ;                                        ;
                    bcf            PortB,WR1              ;-----------------------------------------         ;
                    movlw          b'00011000'            ;   ( )      ;
                    movwf          PortB                  ;                              ;
                    bsf            PortB,WR1              ;                                        ;
                    bcf            PortB,WR1              ;-----------------------------------------         ;
                    clrf           PortB                  ;  (   )         ;
                    bcf            PortB,A0               ;                         ;
                    bsf            PortB,WR1              ;                                       ;
                    bcf            PortB,WR1              ;-----------------------------------------         ;
                    bsf            PortB,A0               ;                         ;
                    movlw          .20                    ;   20                 ;
                    movwf          SCH1                   ;                      ;
STR                 bsf            PortB,WR1              ;                                   ;
                    bcf            PortB,WR1              ;-----------------------------------------         ;
                    decfsz         SCH1,F                 ;                  ;
                    goto           STR                    ;                                ;
                    call           CLERREG                ;                        ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                           ;
;------------------------------------------------------------------------------------------------------------;
                    movlw          .15                    ;                   ;
                    movwf          MEM                    ;                                          ;
                    movlw          0x1C                   ;                          ;
                    movwf          FSR                    ;                             ;
STIRAEM             clrf           Indf                   ;                             ;
                    incf           FSR,F                  ;                                  ;
                    decfsz         MEM,F                  ;          ;
                    goto           STIRAEM                ;                                 ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                ;
;------------------------------------------------------------------------------------------------------------;
                    clrf           TMR0                   ;                                    ;
                    movlw          b'10100000'            ;           ;
                    movwf          IntCon                 ;                        ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                            ;
;------------------------------------------------------------------------------------------------------------;
PROG                call           ZUM                    ;                        ;
                    call           TIMEtemp               ;                 ;
                    call           KNOBKIt                ;                ;
                    call           KNOBKIss               ;   \              ;
                    btfss          FLAG,FSIG              ;              ;
                    goto           ZAPOLNENIE             ;  ,         ;
                    btfsc          ZFLAG,0                ;  ,         ;
                    goto           BRECSP                 ;   ,          ;
ZAPOLNENIE          movlw          0x0A                   ;  t                               ;
                    movwf          ZM1                    ;                                 ;
                    movf           TECNT,W                ;                    ;
                    movwf          ZM2                    ;                                ;
                    movlw          0x0E                   ;                                  ;
                    movwf          ZM3                    ;                                 ;
                    movlw          0x0E                   ;                                  ;
                    movwf          ZM4                    ;                              ;
                    movf           TIMEc,W                ;                    ;
                    movwf          TIMEt                  ;                                        ;
                    call           PER2_10                ;                     ;
                    movf           ZMTH,W                 ;               ;
                    movwf          ZM5                    ;                                  ;
                    movf           ZMTL,W                 ;                       ;
                    movwf          ZM6                    ;                                 ;
                    movf           TIMEm,W                ;              ;
                    movwf          TIMEt                  ;                                        ;
                    call           PER2_10                ;                     ;
                    movf           ZMTH,W                 ;               ;
                    movwf          ZM7                    ;                                ;
                    movf           ZMTL,W                 ;                       ;
                    movwf          ZM8                    ;                                ;
                    movf           TIMEs,W                ;                    ;
                    movwf          TIMEt                  ;                                        ;
                    call           PER2_10                ;          ;
                    movf           ZMTH,W                 ;      ;
                    movwf          ZM9                    ;                                ;
                    movf           ZMTL,W                 ;                                 ;
                    movwf          ZM10                   ;                                ;
                    call           ZAGRUZKA               ;                           ;
                    goto           PROG                   ;                     ;
BRECSP              movlw          0x0E                   ;                  ;
                    movwf          ZM1                    ;---------------------------------------------     ;
                    movwf          ZM2                    ;---------------------------------------------     ;
                    movwf          ZM3                    ;---------------------------------------------     ;
                    movwf          ZM4                    ;---------------------------------------------     ;
                    movwf          ZM5                    ;---------------------------------------------     ;
                    movwf          ZM6                    ;---------------------------------------------     ;
                    movwf          ZM7                    ;---------------------------------------------     ;
                    movwf          ZM8                    ;---------------------------------------------     ;
                    movwf          ZM9                    ;---------------------------------------------     ;
                    movwf          ZM10                   ;---------------------------------------------     ;
                    call           ZAGRUZKA               ;                           ;
                    goto           PROG                   ;                     ;
;************************************************************************************************************;
;                                                                                        ;
;============================================================================================================;
INTERR              bcf            IntCon,GIE             ;                            ;
                    movwf          TEMPw                  ;                               ;
                    movf           Status,W               ;                                   ;
                    movwf          TEMPstatus             ;-----------------------------------------         ;
                    btfss          IntCon,T0IF            ;           ;
                    goto           OUT_PROG               ; ,                    ;
                    btfsc          FLAG,DO                ;                       ;
                    goto           DOSCH                  ; ,                             ;
                    btfsc          FLAG,DO1               ;               ;
                    goto           DOSCH1                 ; ,                             ;
                    incf           INTAIM,F               ;                 ;
                    movf           INTAIM,W               ;       15                 ;
                    sublw          .15                    ;-----------------------------------------         ;
                    btfss          Status,Z               ;-----------------------------------------         ;
                    goto           OUT_PROG               ;   ,           ;
                    bsf            FLAG,DO                ;  ,              ;
                    bsf            Status,RP0             ;                                ;
                    movlw          b'10000101'            ;                 ;
                    movwf          OptionR                ; 64                                   ;
                    bcf            Status,RP0             ;                               ;
                    goto           OUT_PROG               ;                               ;
DOSCH               bcf            FLAG,DO                ;            ;
                    bsf            FLAG,DO1               ;                    ;
                    bsf            Status,RP0             ;                                ;
                    movlw          b'10000000'            ;       ;
                    movwf          OptionR                ; 2                                              ;
                    bcf            Status,RP0             ;                               ;
                    goto           OUT_PROG               ;                               ;
DOSCH1              bcf            FLAG,DO1               ;                   ;
                    bsf            Status,RP0             ;                                ;
                    movlw          b'10000111'            ;        ;
                    movwf          OptionR                ; 256                                            ;
                    bcf            Status,RP0             ;                               ;
                    clrf           INTAIM                 ;                          ;
                    comf           ZFLAG                  ;                    ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                          ;
;------------------------------------------------------------------------------------------------------------;
TIM1                call           PROV01                 ;                     ;
                    btfss          FLAG,T1                ;                  ;
                    goto           TIM2                   ; ,        ;
                    decf           TIME1s,F               ;                          ;
                    movf           TIME1s,W               ;                             ;
                    sublw          .255                   ;                                 ;
                    btfss          Status,Z               ;                  ;
                    goto           TIM2                   ;-------------------------------------------       ;
                    movlw          .59                    ;     59             ;
                    movwf          TIME1s                 ;                                   ;
                    decf           TIME1m,F               ;                                    ;
                    movf           TIME1m,W               ;                              ;
                    sublw          .255                   ;                                   ;
                    btfss          Status,Z               ;      2             ;
                    goto           TIM2                   ;-------------------------------------------       ;
                    movlw          .59                    ;              ;
                    movwf          TIME1m                 ; 59                                    ;
                    decf           TIME1c,F               ;                                      ;
TIM2                call           PROV02                 ;                     ;
                    btfss          FLAG,T2                ;                  ;
                    goto           TIM3                   ; ,       ;
                    decf           TIME2s,F               ;                          ;
                    movf           TIME2s,W               ;                             ;
                    sublw          .255                   ;                                 ;
                    btfss          Status,Z               ;                 ;
                    goto           TIM3                   ;-------------------------------------------       ;
                    movlw          .59                    ;     59             ;
                    movwf          TIME2s                 ;                                   ;
                    decf           TIME2m,F               ;                                    ;
                    movf           TIME2m,W               ;                              ;
                    sublw          .255                   ;                                   ;
                    btfss          Status,Z               ;      3             ;
                    goto           TIM3                   ;-------------------------------------------       ;
                    movlw          .59                    ;              ;
                    movwf          TIME2m                 ; 59                                    ;
                    decf           TIME2c,F               ;                                      ;
TIM3                call           PROV03                 ;                     ;
                    btfss          FLAG,T3                ;                  ;
                    goto           TIM4                   ; ,      4        ;
                    decf           TIME3s,F               ;                          ;
                    movf           TIME3s,W               ;                             ;
                    sublw          .255                   ;                                 ;
                    btfss          Status,Z               ;     4                   ;
                    goto           TIM4                   ;-------------------------------------------       ;
                    movlw          .59                    ;     59             ;
                    movwf          TIME3s                 ;                                   ;
                    decf           TIME3m,F               ;                                    ;
                    movf           TIME3m,W               ;                              ;
                    sublw          .255                   ;                                   ;
                    btfss          Status,Z               ;      4             ;
                    goto           TIM4                   ;-------------------------------------------       ;
                    movlw          .59                    ;              ;
                    movwf          TIME3m                 ; 59                                    ;
                    decf           TIME3c,F               ;                                      ;
TIM4                call           PROV04                 ;                     ;
                    btfss          FLAG,T4                ;                  ;
                    goto           OUT_PROG               ; ,                    ;
                    decf           TIME4s,F               ;                          ;
                    movf           TIME4s,W               ;                             ;
                    sublw          .255                   ;                                 ;
                    btfss          Status,Z               ;                             ;
                    goto           OUT_PROG               ;-------------------------------------------       ;
                    movlw          .59                    ;     59             ;
                    movwf          TIME4s                 ;                                   ;
                    decf           TIME4m,F               ;                                    ;
                    movf           TIME4m,W               ;                              ;
                    sublw          .255                   ;                                   ;
                    btfss          Status,Z               ;                             ;
                    goto           OUT_PROG               ;-------------------------------------------       ;
                    movlw          .59                    ;              ;
                    movwf          TIME4m                 ; 59                                    ;
                    decf           TIME4c,F               ;                                      ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                           ;
;------------------------------------------------------------------------------------------------------------;
OUT_PROG            movlw          b'10100000'            ;                     ;
                    movwf          IntCon                 ;                ;
                    movf           TEMPstatus,W           ;                              ;
                    movwf          Status                 ;-----------------------------------------         ;
                    movf           TEMPw,W                ;                          ;
                    retfie                                ;                      ;
;------------------------------------------------------------------------------------------------------------;
;                                                                                 ;
;------------------------------------------------------------------------------------------------------------;
PROV01              btfss          FLAG,T1                ;               ;
                    return                                ; ,                   ;
                    movf           TIME1c,F               ;           ;
                    btfss          Status,Z               ;                               ;
                    return                                ;                                         ;
                    movf           TIME1m,F               ;                              ;
                    btfss          Status,Z               ;                              ;
                    return                                ;                                         ;
                    movf           TIME1s,F               ;                  ;
                    btfss          Status,Z               ;                              ;
                    return                                ;                                         ;
                    bcf            FLAG,T1                ;  ,         ;
                    bsf            FSTOP,T1               ;                         ;
                    return                                ;                                          ;
PROV02              btfss          FLAG,T2                ;               ;
                    return                                ; ,                   ;
                    movf           TIME2c,F               ;           ;
                    btfss          Status,Z               ;                               ;
                    return                                ;                                         ;
                    movf           TIME2m,F               ;                              ;
                    btfss          Status,Z               ;                              ;
                    return                                ;                                         ;
                    movf           TIME2s,F               ;                  ;
                    btfss          Status,Z               ;                              ;
                    return                                ;                                         ;
                    bcf            FLAG,T2                ;  ,         ;
                    bsf            FSTOP,T2               ;                         ;
                    return                                ;                                          ;
PROV03              btfss          FLAG,T3                ;               ;
                    return                                ; ,                   ;
                    movf           TIME3c,F               ;           ;
                    btfss          Status,Z               ;                               ;
                    return                                ;                                         ;
                    movf           TIME3m,F               ;                              ;
                    btfss          Status,Z               ;                              ;
                    return                                ;                                         ;
                    movf           TIME3s,F               ;                  ;
                    btfss          Status,Z               ;                              ;
                    return                                ;                                         ;
                    bcf            FLAG,T3                ;  ,         ;
                    bsf            FSTOP,T3               ;                         ;
                    return                                ;                                          ;
PROV04              btfss          FLAG,T4                ;            ;
                    return                                ; ,                   ;
                    movf           TIME4c,F               ;           ;
                    btfss          Status,Z               ;                               ;
                    return                                ;                                         ;
                    movf           TIME4m,F               ;                              ;
                    btfss          Status,Z               ;                              ;
                    return                                ;                                         ;
                    movf           TIME4s,F               ;                  ;
                    btfss          Status,Z               ;                              ;
                    return                                ;                                         ;
                    bcf            FLAG,T4                ;  ,         ;
                    bsf            FSTOP,T4               ;                         ;
                    return                                ;                                          ;
;************************************************************************************************************;
                    end                                   ;                                   ;
;************************************************************************************************************;
